<?php

$analyseTableAlign = NULL;
$analyseTableX = 0;
$analyseTableY = 0;
$analyseTableHead = 0;

$analyseTableKeepMap = array();
$analyseTableKeepIndex = 1;
$analyseTableKeepToken = $KeepToken;

function analyseTableKeep($x) {
  # Keep preserves a string from being processed by wiki markups
  global $analyseTableKeepToken,$analyseTableKeepMap,$analyseTableKeepIndex;
  
  $x = preg_replace("/$analyseTableKeepToken(\\d.*?)$analyseTableKeepToken/e", "\$analyseTableKeepMap['\$1']", $x);
  $analyseTableKeepIndex++;
  $analyseTableKeepMap[$analyseTableKeepIndex]=$x;
  return $analyseTableKeepToken.$analyseTableKeepIndex.$analyseTableKeepToken;
}

function analyseTables(&$doc) {
  global $analyseTableKeepToken,$analyseTableKeepMap;
  global $BypassTables;
  if ($BypassTables) return $doc;
  return preg_replace
    ("/$analyseTableKeepToken(\\d.*?)$analyseTableKeepToken/e", "\$analyseTableKeepMap['\$1']",
     preg_replace_callback
     ('|<advtabular(.*?)>(.*?)</advtabular>|s', "analyseAdvancedTable",
      preg_replace_callback
      ('|(<tabular.*?>)(.*?</tabular>)|s', "analyseTable",
       $doc)));

}

function analyseTable($tmatches) {
  // first, get all cell data
  global $analyseTableAlign, $analyseTableY, $analyseTableHead, $analyseTableZ, $analyseTableFoot;

  $table = $tmatches[0];
# deal with pathological case of PmWiki FAQ page!!
  if (preg_match("/<tabular[^>]+preamble=/", $table)) return analyseTableKeep($table);

  $tableX = 0;
  if (preg_match("/<tabular[^>]+class=['\"](long|big)['\"]/", $table)) {
    $tableX = 1;
  }
  $cells = array();
  preg_match_all("|<row.*?>.*?</row>|s", $table, $rmatches, PREG_SET_ORDER);
  $cols = 0;
  foreach($rmatches as $rm) {
    $x = 0;
    preg_match_all("|<cell(.*?)>.*?</cell>|s", $rm[0], $cmatches, PREG_SET_ORDER);
    foreach($cmatches as $cm) {
      $align = 'left';
      if (preg_match("|align=['\"](.+?)['\"]|", $cm[1], $amatches)) {
	$align = $amatches[1];
      }
      $wrap = 1;
      if (preg_match("|wrap=['\"]no['\"]|", $cm[1], $dummy)) {
	$wrap = 0;
      } elseif ($tableX) {
	$align = 'X';
      }
      $colspan = 1;
      if (preg_match("|colspan=['\"](.+?)['\"]|", $cm[1], $csmatches)) {
	$colspan = $csmatches[1];
      }
      if ($colspan == 1) {
	$cells[$x][$align]++;
	$cells[$x]['wrap'] += $wrap;
      }
      $x += $colspan;
      if ($cols < $x) { $cols = $x; }
    }
  }
  $colalign = array();
  $preamble = '';
  for($i = 0; $i < $cols; $i++) {
    $lnum = $cells[$i]['left'];
    $cnum = $cells[$i]['center'];
    $rnum = $cells[$i]['right'];
    $xnum = $cells[$i]['X'];
    $max = max($lnum,$rnum,$cnum,$xnum);
    $align = 'left'; // default
    if ($lnum == $max) $align = 'left';
    if ($rnum == $max) $align = 'right';
    if ($cnum == $max) $align = 'center';
    if ($tableX && $cells[$i]['wrap'] > 0) $align = 'X';
    $colalign[$i] = $align;
    if ($cells[$i]['wrap'] == 0) {
      $colalign['wrap'][$i] = 0;
      $preamble .= substr($align, 0, 1);
    } else {
      $colalign['wrap'][$i] = 1;
      $preamble .= strtoupper(substr($align, 0, 1));
    }
  }

  // now, to clean up the table...
  $analyseTableAlign = $colalign;
  $analyseTableY = 0;
  $analyseTableZ = count($rmatches);
  $table = preg_replace_callback("|<row.*?>.*?</row>|s", "analyseRow", $table);

  $hline = '<hline from="1" to="'.$cols.'" trim="lr" />';
  if ($analyseTableHead == $cols) {
    $table = preg_replace("|(<tabbody>)\s*(<row.*?>.*?</row>)|s",
			  '<tabhead>$2'.($tableX ? $hline : '').'</tabhead>$1'.($tableX ? '' : $hline), 
			  $table);
  }
  
  $table = preg_replace("|<foot(row.*?>)|", 
                        (($analyseTableFoot == $cols) ? $hline : '').'<$1', $table);

  $table = preg_replace("|<tabular(.*?)>|s", 
			'<tabular$1 preamble="'.$preamble.($tableX ? '" style="'.$cols : '').'">', $table);

  return analyseTableKeep($table);
}

function analyseRow($rmatches) {
  global $analyseTableX, $analyseTableY, $analyseTableHead, $analyseTableZ, $analyseTableFoot;
  $row = $rmatches[0];
  $analyseTableX = 0;
  $analyseTableZ--;
  if ($analyseTableY == 0) { $analyseTableHead = 0; $analyseTableFoot = 0; }
  $row = preg_replace_callback("|<cell(.*?)>(.*?)</cell>|s", 
			       "analyseCell", $row);
#  if ($analyseTableY == 0) { $analyseTableHead = $analyseTableHead > 0; }
  $analyseTableY++;
  if ($analyseTableZ == 0) $row = str_replace('<row','<footrow',$row);
  return $row;
}

function analyseCell($cmatches) {
  global $analyseTableX, $analyseTableAlign, $analyseTableY, $analyseTableHead, $analyseTableZ, $analyseTableFoot;
  $cell = $cmatches[0];
  $attr = $cmatches[1];
  $text = trim($cmatches[2]);
  $emph = preg_match('/^<em>.*?<\/em>$/',$text);
  $text = preg_replace("|<[^>]+>|s", "", $text);
#  $text = preg_replace("|\\s+|s", "", $text);

  $align = 'left';
  $xwrap = $wrap = 'yes';
  $title = 0+($text == "" || $text == "&nbsp;");

  if (preg_match("|align=['\"](.+?)['\"]|", $attr, $amatches)) {
    $align = $amatches[1];
  }
  $colspan = 1;
  if (preg_match("|colspan=['\"](.+?)['\"]|", $attr, $csmatches)) {
    $colspan = $csmatches[1];
  }
  $rowspan = 1;
  if (preg_match("|rowspan=['\"](.+?)['\"]|", $attr, $rsmatches)) {
    $rowspan = $rsmatches[1];
  }
  if (preg_match("|wrap=['\"](.+?)['\"]|", $attr, $wmatches)) {
    $xwrap = $wrap = $wmatches[1];
  }
  if (preg_match("|title=['\"]true['\"]|", $attr, $wmatches)) {
    $title = 1;
    $attr = preg_replace("|title=['\"]true['\"]|", "", $attr);
  }

  // if column is unwrapped, then don't bother specifying alignment.  this makes tabulary happier.
  if ($wrap == 'no' && $align == $analyseTableAlign[$analyseTableX] && $analyseTableAlign['wrap'][$analyseTableX] == 0) {
    $wrap = 'yes';
  }

  if ($wrap == 'yes' && $colspan == 1 && strcmp($align,$analyseTableAlign[$analyseTableX]) == 0) {
    $attr = "wrap='$xwrap'";
  } else {
    $attr = "align='$align' wrap='$xwrap'";
    if ($colspan != 1) $attr .= " colspan='$colspan'";
  }
  if ($rowspan != 1) $attr .= " class='rowspan' style='$rowspan'";
  $cell = preg_replace("|<cell(.*?)>|s", "<cell $attr>", $cell);

  $analyseTableX += $colspan;
  if ($title && $analyseTableY == 0) {
    $analyseTableHead+= $colspan;
  } elseif (($title || $emph) && $analyseTableZ == 0) {
    $analyseTableFoot+= $colspan;
  }
  return $cell;
}

function analyseAdvancedTable($tmatches) {
  global $colCounter;
  $table = '<tabular>' . $tmatches[2]. '</tabular>';
  $colWidths = array();
  preg_match_all("|<row.*?>.*?</row>|s", $table, $rmatches, PREG_SET_ORDER);
  $cols = 0;
  foreach($rmatches as $rm) {
    $x = 0;
    preg_match_all("|<cell(.*?)>.*?</cell>|s", $rm[0], $cmatches, PREG_SET_ORDER);
    foreach($cmatches as $cm) {
      $colspan = 1;
      if (preg_match("|colspan=['\"](.+?)['\"]|", $cm[1], $csmatches)) {
        $colspan = $csmatches[1];
      } 
      if (preg_match("|width=['\"](.+?)%['\"]|", $cm[1], $wmatches)) {
        $colWidths[$x] = $wmatches[1];
      }
      $x += $colspan;
      if ($cols < $x) { $cols = $x; }
    }
  }
  $tabwidth  = (preg_match("|width=['\"](.+?)%['\"]|", $tmatches[1], $tw)) ? $tw[1]/100 : 1;
  $cellwidth = $tabwidth * (1.0-(($cols+1)*0.018)) / $cols;

  $vr = (preg_match("|class=['\"](plain)['\"]|", $tmatches[1])) ? '|' : '';
  $align = $vr; for ($i=$cols; $i>0; $i--) { $align .= 'l'.$vr; }

  $big = (preg_match("|class=['\"](big)['\"]|", $tmatches[1])) ? 'big' : '';

  $colCounter = 0;
  
  $rHead = tabheadHeader($rmatches[0][0], $cols);
  $hline = '<hline'.($vr ? '' : ' from="1" to="'.$cols.'" trim="lr"').' />';

  return analyseTableKeep(preg_replace(array("|(<cell.*?>)(.*?)(</cell>)|se",
			    "|<hline.*?/>|",
			    "|(<tabular)(>)|",
			    "|(<tabbody>)(<row>.*?</row>)(<hline.*?/>)(<row>.*?</row>)|s"),
		      array("cellPatchColspan(PSS('\$1'),PSS('\$2')).' width=\"'.cellwidthMultiple(PSS('\$1'),\$colWidths,$cols)*\$cellwidth.'\">'".
			    ".cellApplyCellpatch(PSS('\$2')).'</group>'.cellApplyColpatch('\$3')",
			    $hline,
			    "\\1 preamble='$align' class='{$big}advanced' style='$cols'\\2",
			    "<tabhead>\\2".($rHead ? "\\3" : "")."</tabhead>\\1".($rHead ? "" : "\\3")."\\4"),
		      $table));

}

function cellPatchColspan($cell, $contents) {
  global $ColspanCounter, $ColspanAttr, $SimpleColspan;
  if (preg_match('/^[^\n]+\n$/',$contents)) 
      $SimpleColspan = (strstr($cell,' colspan='));
  $cell = $cell.'<group class="'.($SimpleColspan ? 'simple' : 'cell').'"';
  if ($SimpleColspan) return $cell;
# not $SimpleColspan)
  if (preg_match("|\s+style=['\"](head)['\"]|", $cell, $st))
      $cell = str_replace($st[0], '', $cell).$st[0];
  if (preg_match("|\s+align=['\"]([^\s]+?)['\"]|", $cell, $al)) 
      $cell = str_replace($al[0], '', $cell).$al[0]; 
  if (preg_match("|\s+colspan=['\"](\d+?)['\"]|", $cell, $cs))
      $ColspanCounter = $cs[1];
  else return $cell;
  $cell = str_replace($cs[0], '', $cell);
  if (preg_match('/<cell(.*?)>/',$cell,$at)) $ColspanAttr = $at[1];
  return $cell;
}
function cellApplyCellpatch($contents) {
  global $SimpleColspan;
  $contents = ($SimpleColspan) ? str_replace('<p>','<p style="simple">',$contents) : str_replace(" </p>\n<p>"," ",$contents);
  return $contents;
}
function cellApplyColpatch($cell) {
  global $ColspanCounter, $ColspanAttr, $SimpleColspan;
  for($i=1;$i<$ColspanCounter;$i++)
    $cell .= ($SimpleColspan ? '' : '<cell'.$ColspanAttr.'>&hellip;</cell>');
  $ColspanCounter = 1; $ColspanAttr = '';
  $SimpleColspan = false;
  return $cell;
}
function cellwidthAdjust($cell,$colWidths,$cols) {
  global $colCounter;
  if ($colCounter>=$cols) $colCounter = 0;
  $cspan = (preg_match("|colspan=['\"](\d+?)['\"]|", $cell, $cs)) ? $cs[1] : 1; 
  $multiple = ($colWidths[$colCounter]) ? $colWidths[$colCounter]*$cols/100 : 1;
  $colCounter += $cspan;
  return $multiple;
}

function cellwidthMultiple($cell,$colWidths,$cols) {
  global $colCounter, $SimpleColspan;
  if ($colCounter>=$cols) $colCounter = 0;
  $cspan = (preg_match("|colspan=['\"](\d+?)['\"]|", $cell, $cs)) ? $cs[1] : 1; 
  if ($SimpleColspan) {
    $multiple = 0;
    for($i=$colCounter;$i<$colCounter+$cspan;$i++) 
      $multiple += ($colWidths[$i]) ? $colWidths[$i]*$cols/100 : 1;
  } else {
    $multiple = ($colWidths[$colCounter]) ? $colWidths[$colCounter]*$cols/100 : 1;
  }
  $colCounter += $cspan;
  return $multiple;
}

function tabheadHeader($row, $cols) {
  $head = 0;
  preg_match_all("|<cell.*?>(.*?)</cell>|s", $row, $cmatches, PREG_SET_ORDER);
  foreach($cmatches as $cm)
    if (preg_match("|^<p><visual\s+markup=['\"]bf['\"]>(.+?)</visual>\s*</p>|", $cm[1])) $head++;
    elseif (preg_match("|^<cell[^>]*\s+style=['\"]head['\"]>|", $cm[0])) $head++;
  return ($head==$cols);
}

?>